const express = require('express');
const bodyParser = require('body-parser');
const cors = require('cors');
const path = require('path');

// Correct the import statement for the router
const UserRouter = require('./router/admin_router');

const app = express();

app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: true }));
app.use(cors());

// Serve static files from the "uploads" directory
app.use('/uploads', express.static(path.join(__dirname, 'uploads')));

// Use the correct router for user-related routes
app.use('/', UserRouter);

app.get('/viewpost/:post_id', (req, res) => {
  const post_id = req.params.post_id;
  // Implement logic to fetch and return post details based on post_id
  res.send(`Post details for post ID ${post_id}`);
});

app.listen(3001, () => {
  console.log('Server running at http://localhost:3001');
});
