const connection = require("../model/connection");
const languageMessage = require("./languageMessage");

const MostPopular = (request, response) => {
  const checkViews = "SELECT view_id, video_id, view_count FROM view_master ORDER BY view_count DESC";

  connection.query(checkViews, (err, viewRes) => {
    if (err) {
      return response
        .status(200)  
        .json({ success: false, msg: languageMessage.internalServerError });
    }

    if (viewRes.length <= 0) {
      return response
        .status(200)  
        .json({ success: false, msg: languageMessage.ErrorFindViewCount });
    }

    let result = [];
    let processedCount = 0; 

    for (let i = 0; i < viewRes.length; i++) {
      const element = viewRes[i];
      const FetchDataPost_master =
        "SELECT title, video, thumbnail, createtime FROM post_master WHERE post_id = ?";

      connection.query(FetchDataPost_master,[element.video_id],(err, postRes) => {
          processedCount++;
          if (err) {
            return response
              .status(200) 
              .json({
                success: false,
                msg: languageMessage.internalServerError,
              });
          }

        
          if (postRes.length > 0) {
            result.push({
              view_id: element.view_id,
              view_count: element.view_count,
              title: postRes[0].title,
              video: postRes[0].video,
              thumbnail: postRes[0].thumbnail,
              createtime: postRes[0].createtime,
            });
          }

            

          if (processedCount === viewRes.length) {
            if (result.length > 0) {
              return response.status(200).json({ success: true, msg: languageMessage.msgDataFound, result });
            } else {
              return response
                .status(200) 
                .json({
                  success: false,
                  msg: languageMessage.ErrorFindViewCount,
                });
            }
          }
        }
      );
    }
  });
};

module.exports = { MostPopular };
