const crypto = require('crypto');
const connection = require('../model/connection');
// const moment = require('moment');

async function hashPassword(password) {
  const hash = crypto.createHash('md5');

  hash.update(password);

  return hash.digest('hex');
}

function generateOTP(limit) {
  var digits = '0123456789';
  let OTP = '';
  for (let i = 0; i < limit; i++) {
    OTP += digits[Math.floor(Math.random() * 10)];
  }
  return OTP;
}

async function getUserData(userId) {
  const query =
    'SELECT `user_id`, `login_type`, `login_type_first`, `user_type`, `email`, `name`, `f_name`, `l_name`, `dob`, `age`, `height`, `phone_code`, `mobile`, `otp`, `otp_verify`, `image`, `gender`, `address`, `latitude`, `longitude`, `zipcode`, `bio`, `active_flag`, `approve_flag`, `profile_complete`, `language_id`, `facebook_id`, `google_id`, `twitter_id`, `instagram_id`, `apple_id`, `notification_status`, `delete_reason`, `createtime`, `updatetime`, `mysqltime`, `signup_step` FROM user_master WHERE user_id = ? and delete_flag=0';

  // eslint-disable-next-line no-useless-catch
  try {
    const results = await new Promise((resolve, reject) => {
      connection.query(query, [userId], (error, results) => {
        if (error) {
          reject(error);
        } else {
          resolve(results);
        }
      });
    });

    if (results.length > 0) {
      const userData = results[0];
      const userDataArray = {
        user_id: userData.user_id,
        login_type: userData.login_type,
        login_type_first: userData.login_type_first,
        user_type: userData.user_type,
        email: userData.email,
        name: userData.name,
        f_name: userData.f_name,
        l_name: userData.l_name,
        dob: userData.dob,
        age: userData.age,
        phone_code: userData.phone_code,
        mobile: userData.mobile,
        otp: userData.otp,
        otp_verify: userData.otp_verify,
        image: userData.image,
        gender: userData.gender,
        address: userData.address,
        latitude: userData.latitude,
        longitude: userData.longitude,
        zipcode: userData.zipcode,
        active_flag: userData.active_flag,
        approve_flag: userData.approve_flag,
        profile_complete: userData.profile_complete,
        language_id: userData.language_id,
        facebook_id: userData.facebook_id,
        google_id: userData.google_id,
        apple_id: userData.apple_id,
        notification_status: userData.notification_status,
        delete_reason: userData.delete_reason,
        createtime: userData.createtime,
        updatetime: userData.updatetime,
        bio: userData.bio,
        signup_step: userData.signup_step
      };
      return userDataArray; // Return user data object
    } else {
      return null; // Return null if user not found
    }
  } catch (error) {
    throw error; // Throw error for higher-level handling
  }
}

module.exports = { hashPassword, generateOTP, getUserData };
