const express = require('express');
const router = express.Router();
const upload = require('../controller/multer');
const {
  FetchUser,
  fetchuserDate,
  ViewUser,
  DeleteUser,
  FetchDeleteUser,
  FetchPostDetails,
  ViewPost,
  DeletePost,
  FetchCategory,
  AddCategory,
  DeleteCategory,
  UpdateCategory,
  FetchAllSubscriptions,
  AddSubscription,
  DeleteSubscription,
  EditSubscription,
  GetAllAnnouncements,
  DeleteAnnouncements,
  FetchSubscribedUsers,
  FetchReportedContent,
  EditReportedContent,
  fetchaboutcontent,
  updateContent,
  FetchContactUs,
  SendMail,
  updateStatus,
  BroadcastAll,
  Users,
  FetchSubscribedUsersByDate,
  AdminData,
  UpdateAdminPassword,
  fetchSubscriptionById,
  fetchpostdetailsById,
  getAnnouncementsById,
  UpdateAdminProfile,
  UserCount,
  Adminlogin,
  AdminForgetPassword,
  AdminForgetNewPassword,
  CheckAdminEmail
} = require('../controller/admin_controller');

router.get('/fetchuser', upload.none(), FetchUser);
router.get('/fetchuserDate', upload.none(), fetchuserDate);
router.get('/FetchSubscribedUsersByDate', upload.none(), FetchSubscribedUsersByDate);
router.get('/viewuser/:user_id', ViewUser);
router.post('/deleteUser', upload.none(), DeleteUser);
router.get('/fetchdelete', upload.none(), FetchDeleteUser);
router.get('/fetchpostdetails', upload.none(), FetchPostDetails);
router.get('/viewpost/:post_id', upload.none(), ViewPost);
router.post('/deletepost', upload.none(), DeletePost);
router.get('/fetchcategory', FetchCategory);
router.post('/addcategory', upload.none(), AddCategory);
router.post('/deletecategory', upload.none(), DeleteCategory);
router.post('/updatecategory', upload.none(), UpdateCategory);
router.get('/getAllSubscription', upload.none(), FetchAllSubscriptions);
router.post('/addsubscription', upload.none(), AddSubscription);
router.post('/DeleteSubscription', upload.none(), DeleteSubscription);
router.post('/EditSubscription', upload.none(), EditSubscription);
router.get('/getAnnouncements', upload.none(), GetAllAnnouncements);
router.post('/deleteAnnouncements', upload.none(), DeleteAnnouncements);
router.get('/FetchSubscribedUsers', upload.none(), FetchSubscribedUsers);
router.get('/FetchReportedContent', upload.none(), FetchReportedContent);
router.post('/EditReportedContent', upload.none(), EditReportedContent);
router.get('/fetchaboutcontent', upload.none(), fetchaboutcontent);
router.post('/updateContent', upload.none(), updateContent);
router.get('/FetchContactUs', upload.none(), FetchContactUs);
router.post('/SendMail', upload.none(), SendMail);
router.post('/updateStatus', upload.none(), updateStatus);
router.post('/BroadcastAll', upload.none(), BroadcastAll);
router.get('/AdminData', upload.none(), AdminData);
router.post('/UpdateAdminProfile', upload.single('image'), UpdateAdminProfile);
router.post('/UpdateAdminPassword', upload.none(), UpdateAdminPassword);
router.get('/fetchSubscriptionById/:user_id', fetchSubscriptionById);
router.get('/fetchpostdetailsById/:user_id', fetchpostdetailsById);
router.get('/getAnnouncementsById/:user_id', getAnnouncementsById);
router.get('/UserCount', upload.none(), UserCount);
// fetchuser
router.get('/users', upload.none(), Users);

router.post('/Adminlogin', upload.none(), Adminlogin);
router.post('/AdminForgetPassword', upload.none(), AdminForgetPassword);
router.post('/AdminForgetNewPassword', upload.none(), AdminForgetNewPassword);
router.post('/CheckAdminEmail', upload.none(), CheckAdminEmail);
module.exports = router;
